Summary: Web application monitoring the computing element
Name: glite-ce-monitor
Version: %{extversion}
Release: %{extage}.%{extdist}
License: Apache Software License
Vendor: EMI
URL: http://glite.cern.ch/
Group: System Environment/Libraries
BuildArch: noarch
BuildRequires: %{!?extbuilddir: glite-ce-monitor-api-java, } ant
BuildRequires: jakarta-commons-codec, jakarta-commons-httpclient, jakarta-commons-logging
BuildRequires: %{!?extbuilddir: emi-trustmanager-axis2, } classpathx-jaf, jclassads
Requires: glite-ce-monitor-api-java, classpathx-jaf, emi-trustmanager-axis2
Requires(post): openssl
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: yes
Source: %{name}-%{version}-%{release}.tar.gz

%if %{extdist} == "sl6"
%global _tomcat tomcat6
%else
%global _tomcat tomcat5
%endif

%description
The CE monitor service is a web application that 
publishes information about the Computing Element

%prep 

%setup -c -q 

%build
%{!?extbuilddir:%define extbuilddir "--"}
if test "x%{extbuilddir}" == "x--" ; then
  printf "dist.location=%{buildroot}
stage.location=
module.version=%{version}">.configuration.properties
  ant
fi

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}
%{!?extbuilddir:%define extbuilddir "--"}
if test "x%{extbuilddir}" == "x--" ; then
  ant install
else
  mkdir -p %{buildroot}/usr/share/java
  cp %{extbuilddir}/usr/share/java/*.jar %{buildroot}/usr/share/java
  mkdir -p %{buildroot}/usr/share/glite-ce-monitor/modules
  cp %{extbuilddir}/usr/share/glite-ce-monitor/modules/* %{buildroot}/usr/share/glite-ce-monitor/modules
  mkdir -p %{buildroot}/usr/share/glite-ce-monitor/services
  cp %{extbuilddir}/usr/share/glite-ce-monitor/services/* %{buildroot}/usr/share/glite-ce-monitor/services
  mkdir -p %{buildroot}/etc/glite-ce-monitor
  cp %{extbuilddir}/etc/glite-ce-monitor/*.template %{buildroot}/etc/glite-ce-monitor
  cp %{extbuilddir}/etc/glite-ce-monitor/*.properties %{buildroot}/etc/glite-ce-monitor
  mkdir -p %{buildroot}/usr/share/doc/glite-ce-monitor-%{version}
  cp %{extbuilddir}/usr/share/doc/glite-ce-monitor-%{version}/LICENSE %{buildroot}/usr/share/doc/glite-ce-monitor-%{version}
fi

%clean
rm -rf %{buildroot}

%pre
for((idx=0; idx<5; idx++)) ; do
  /sbin/service %{_tomcat} stop
  if [ $? == 0 ] ; then idx=5; else sleep 5; fi
done

%if %{extdist} == "sl5"
# Remove the axis1-based installation 
if [ -d /var/lib/%{_tomcat}/webapps/ce-monitor ] ; then
  rm -rf /var/lib/%{_tomcat}/webapps/ce-monitor
  rm -f /etc/%{_tomcat}/Catalina/localhost/ce-monitor.xml
  rm -rf /var/cache/%{_tomcat}/work/Catalina/localhost/ce-monitor
fi
%endif

%post
# Do not overwrite axis2-based installation
if [ ! -L /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services/glite-ce-monitor.aar ] ; then

  cp -R /usr/share/axis2/webapp /var/lib/%{_tomcat}/webapps/ce-monitor || exit 1
  
  ln -s /usr/share/java/jclassads/cedar.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/jclassads/classad.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/argus-pep-api-java.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/argus-pep-common.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/trustmanager.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/bcprov.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/glite-ce-common-java.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/glite-ce-monitor-api-java.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/glite-ce-monitor.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/trustmanager-axis2.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib
  ln -s /usr/share/java/voms-api-java.jar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib

%if %{extdist} == "sl6"  
  # set allowLinking option for tomcat6
  mkdir /var/lib/%{_tomcat}/webapps/ce-monitor/META-INF
  echo '<Context override="true" allowLinking="true"></Context>' > /var/lib/%{_tomcat}/webapps/ce-monitor/META-INF/context.xml
%endif

  ln -s /usr/share/glite-ce-monitor/modules/glite-ce-monitor-authorization.mar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules
  rm /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules/modules.list
  for item in `ls /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules/*.mar`; do 
    echo `basename $item` >> /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules/modules.list ; 
  done
  
  ln -s /usr/share/glite-ce-monitor/services/glite-ce-monitor.aar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services
  rm /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services/services.list
  for item in `ls /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services/*.aar`; do 
    echo `basename $item` >> /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services/services.list ; 
  done
  
fi

# Axis Servlet configuration
# customization of axis2.xml (admin password is deprecated)
REPLACE1='s|__CHANGE_SERVICE__|/etc/glite-ce-monitor/cemonitor-config.xml|g'
REPLACE2='s|__CHANGE_LOG4J__|/etc/glite-ce-monitor/log4j.properties|g'
TMPPWD=`openssl rand -base64 15`
REPLACE3='s|__CHANGE_PWD__|'$TMPPWD'|g'
  
sed "$REPLACE1 ; $REPLACE2 ; $REPLACE3" /etc/glite-ce-common-java/axis2.xml > /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml
chmod 600 /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml
chown tomcat.tomcat /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml
# cannot use symlinks for the following files:
cp -f /etc/glite-ce-common-java/web.xml /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/

if [ $1 -eq 1 ] ; then  
# Creation of the back-end and log dir
  if [ ! "x`grep tomcat /etc/passwd`" == "x" ] ; then
    mkdir -p /var/cemonitor
    chown tomcat:tomcat /var/cemonitor
    chmod 755 /var/cemonitor
    
    mkdir -p /var/log/cemonitor
    chown tomcat:tomcat /var/log/cemonitor
    chmod 755 /var/log/cemonitor
  fi

  /sbin/service %{_tomcat} start

fi

%preun
if [ $1 -eq 0 ] ; then

  for((idx=0; idx<5; idx++)) ; do
    /sbin/service %{_tomcat} stop
    if [ $? == 0 ] ; then idx=5; else sleep 5; fi
  done

  if [ -d /var/cemonitor ] ; then
    rm -rf /var/cemonitor
  fi
  
  if [ -d /var/lib/%{_tomcat}/webapps/ce-monitor ] ; then
    rm -rf /var/lib/%{_tomcat}/webapps/ce-monitor
  fi

  if [ -e /etc/%{_tomcat}/Catalina/localhost/ce-monitor.xml ] ; then
    rm -f /etc/%{_tomcat}/Catalina/localhost/ce-monitor.xml
  fi

fi

%postun
/sbin/service %{_tomcat} start

%files
%defattr(-,root,root)
%dir /etc/glite-ce-monitor/
%config(noreplace) /etc/glite-ce-monitor/cemonitor-config-argus.xml.template
%config(noreplace) /etc/glite-ce-monitor/cemonitor-config-gjaf.xml.template
%config(noreplace) /etc/glite-ce-monitor/log4j.properties
/usr/share/java/*.jar
/usr/share/glite-ce-monitor/modules/*
/usr/share/glite-ce-monitor/services/*
%dir /usr/share/doc/glite-ce-monitor-%{version}/
%doc /usr/share/doc/glite-ce-monitor-%{version}/LICENSE

%changelog
* %{extcdate} CREAM group <cream-support@lists.infn.it> - %{extversion}-%{extage}.%{extdist}
- %{extclog}


