/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */

import java.net.URI;

import javax.xml.namespace.QName;

import org.apache.axis.MessageContext;
import org.apache.axis.encoding.DeserializerFactory;
import org.apache.axis.encoding.TypeMapping;
import org.apache.axis.encoding.TypeMappingImpl;
import org.apache.axis.encoding.TypeMappingRegistryImpl;
import org.apache.axis.encoding.ser.BeanDeserializerFactory;
import org.apache.axis.encoding.ser.BeanSerializerFactory;
import org.apache.axis.server.AxisServer;
import org.glite.ce.monitor.holder.ActionHolder;
import org.glite.ce.monitor.holder.SensorHolder;
import org.glite.ce.monitorapij.sensor.Sensor;
import org.glite.ce.monitorapij.types.CEMonResource;
import org.glite.ce.monitorapij.types.Action;

import junit.framework.TestCase;

/**
 * @author borgia
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ActionHolderTest extends TestCase {


	private ActionHolder actionHolder = null;
	   private MessageContext messageContext = null;
	   private AxisServer axisServer = null;
	   private String path ="";
	   private Action action =null;
	   private Action[] actions = null;



  /*
   * @see TestCase#setUp()
   */
  protected void setUp( ) throws Exception {
	TestUtilities testUtilities = new TestUtilities();
   	messageContext= testUtilities.getMessageContext();
  	path = (String)messageContext.getProperty( "resourceURI" );
//  	System.out.println(messageContext.getProperty( "resourceURI" ));
  	URI resourceConfigPath = new URI( path );
  	path = (String)messageContext.getProperty( "sensorConfigURI" );
//  	System.out.println(messageContext.getProperty( "sensorConfigURI" ));
  	URI resourcePath = new URI( path );

   actionHolder = new ActionHolder( messageContext, resourcePath, resourceConfigPath );
  }
	public void testActionHolder() {
		assertNotNull(actionHolder);
	}

	public void testGetAction() {
		Action result = actionHolder.getAction(0);
		assertNull(result);
		
	   	action = new Action();
	   	action.setId(1);
	   	actionHolder.addResource(action);
	   	result = actionHolder.getAction(1);
	   	assertEquals(1,result.getId().intValue());
	   	actionHolder.removeResource(action);
	}

	/*
	 * Class under test for Action[] getActions()
	 */
	public void testGetActions() {
	actions = actionHolder.getActions( );
   	assertEquals(0,actions.length);

   	Action action = new Action();
   	action.setId(1);
    actionHolder.addResource(action);
   	actions = actionHolder.getActions( );
   	assertEquals(1,actions.length);
   	actionHolder.removeResource(action);
	}

	/*
	 * Class under test for Action[] getActions(String)
	 */
	public void testGetActionsString() {
		actions = actionHolder.getActions("test action");
		assertEquals(0,actions.length);
		Action action = new Action();
	   	action.setName("test action");
	   	action.setId(1);
	    actionHolder.addResource(action);
		actions = actionHolder.getActions("test action");
	    assertEquals(actions[0].getName(),"test action");
	}

}
