/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.axis.InternalException;
import org.apache.axis.MessageContext;
import org.apache.axis.deployment.wsdd.WSDDDeployment;
import org.apache.xerces.dom.AttrImpl;
import org.apache.xerces.parsers.DOMParser;
import org.glite.ce.monitor.holder.SubscriptionHandler;
import org.glite.ce.monitorapij.types.Subscription;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
//import org.xml.sax.helpers.AttributeListImpl;
//import org.xml.sax.helpers.AttributesImpl;
import org.xml.sax.helpers.XMLReaderFactory;

import junit.framework.TestCase;


/**
 * @author Antonino Stefano Borgia (stefano.borgia@pd.infn.it)
 *
 */
public class SubscriptionHandlerTest extends TestCase {
   
   private Subscription[] subscriptionArray = null;
   private SubscriptionHandler subscriptionHandler = null;
   private MessageContext messageContext = null;

   public static void main( String[] args ) {
      junit.textui.TestRunner.run( SubscriptionHandlerTest.class );
   }
   
   protected void setUp() throws Exception {
   	TestUtilities testUtilities = new TestUtilities();
   	messageContext= testUtilities.getMessageContext();
   	subscriptionHandler = new SubscriptionHandler(messageContext,getSubscriptionElement());
   }



   private Element getSubscriptionElement(){
   	Element subscriptionElement = null;
	String xmlFile = (String) messageContext.getProperty("predefinedSubscriptionListPath");
   	DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
    DocumentBuilder docBuilder;
	try {
		docBuilder = docBuilderFactory.newDocumentBuilder();
		Document doc = docBuilder.parse(xmlFile);
		subscriptionElement = doc.getDocumentElement();
//		subscriptionElement.normalize();
	} catch (ParserConfigurationException e) {
		e.printStackTrace();
	} catch (SAXException e) {
		e.printStackTrace();
	} catch (IOException e) {
		e.printStackTrace();
	}

	
//   	Element subscriptionElement = null;
//   	
//   	String xmlFile = (String) messageContext.getProperty("predefinedSubscriptionListPath");
// 	DOMParser parser = new DOMParser();
// 	WSDDDeployment wsddDeployment = null;
// 	try {
// 	  parser.parse(xmlFile);
// 	} catch (SAXException se) { 
// 		se.printStackTrace(); }
// 	catch (InternalException ioe) {
// 		ioe.printStackTrace(); } 
// 	catch (IOException e) {
//		e.printStackTrace();
//	}
// 	Document document = parser.getDocument();
// 	subscriptionElement = document.getDocumentElement();
//   	
//   	
   	return subscriptionElement;
   	
   }

   public void testSubscriptionHandler( ) {
      assertNotNull(subscriptionHandler);
   }


   public void testGetSubscription(){
   	Subscription subscription = subscriptionHandler.getSubscription();
   	assertNull(subscription);
   //   subscriptionArray = getSubscriptions("test/subscription.xml");
    //  assertEquals(2,subscriptionArray.length);
   }

   public void testGetValue(){
   	    Object object = subscriptionHandler.getValue();
   	    assertNull(object);
   }

}
