/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Antonino Stefano Borgia <stefano.borgia@pd.infn.it>
 *
 */

import org.glite.ce.monitorapij.sensor.AbstractSensor;
import org.glite.ce.monitorapij.sensor.SensorException;
import org.glite.ce.monitorapij.types.Property;


public class TestSensor extends AbstractSensor {
   private Runtime r;

   /** Creates a new instance of CEMonitor */
   public TestSensor( ) {
      super( "TestSensor", "CE_MONITOR");
      Property[] properties = new Property[] { 
            new Property( "executionDelay", "60000" )
         };
         
         setProperty( properties );
   }
   

   public void init( ) throws SensorException {
      addFormat( new TestFormat( "Test Dialect" ) ); 
      r = Runtime.getRuntime( );      
   }


   public void execute( ) throws SensorException {
       String[] message = new String[] {"TEST"};
      fireSensorEvent( new TestSensorEvent( this, System.currentTimeMillis( ), message ) );
      
   }
}
